﻿using System;
using System.Windows;
using System.Windows.Input;
using WickedFlame.Core.Shapes;

namespace WickedFlame.Core.Tools
{
	public class EllipseTool : FactoryTool
	{
        public EllipseTool()
            : base()
        {
        }

        protected override VectorShape CreateShape(Point mousePosition)
        {
            var shape = new EllipseShape((int)mousePosition.X, (int)mousePosition.Y, 1, 1);

            shape.StrokeThickness = ShapePropertySettings.Settings.StrokeThickness;
            shape.Stroke = ShapePropertySettings.Settings.Stroke;
            shape.Fill = ShapePropertySettings.Settings.Fill;

            return shape;
        }

        public override void OnMouseLeftButtonUp(DrawingCanvas sender, System.Windows.Input.MouseButtonEventArgs e)
		{
            //Add object to history
            var shape = sender.SelectedLayer.ShapeList.TopShape as EllipseShape;
            if (shape != null)
            {
                sender.PushHistoryCommand(new WickedFlame.Core.History.AddCommand(shape, sender.SelectedLayerIndex));
                shape.CallChangeEndHandler();
            }
        }

        public override void OnMouseMove(DrawingCanvas sender, System.Windows.Input.MouseEventArgs e)
		{
            if (e.LeftButton == MouseButtonState.Pressed)
            {
                var shape = sender.SelectedLayer.ShapeList.TopShape as EllipseShape;
                if (shape != null)// CanvasManager.SelectedObject != null)
                {
                    System.Windows.Point m = Mouse.GetPosition(sender);
                    //var rect = CanvasManager.SelectedObject as WickedFlame.VECore.VectorShape.VECEllipse;

                    if (m.Y > (shape.Y + (shape.Height / 2)) &&
                        m.X > (shape.X + (shape.Width / 2)))//lower right
                        shape.MoveTracker(new Point((int)m.X, (int)m.Y), 3);
                    else if (m.Y > (shape.Y + (shape.Height / 2)) &&
                        m.X < (shape.X + (shape.Width / 2)))//lower left
                        shape.MoveTracker(new Point((int)m.X, (int)m.Y), 4);
                    else if (m.Y < (shape.Y + (shape.Height / 2)) &&
                        m.X < (shape.X + (shape.Width / 2)))//upper left
                        shape.MoveTracker(new Point((int)m.X, (int)m.Y), 1);
                    else//upper right
                        shape.MoveTracker(new Point((int)m.X, (int)m.Y), 2);
                }
            }
		}
	}
}
