﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WickedFlame.Core;

namespace WickedFlame.Util
{
	/// <summary>
	/// Represents a element that can edit and manage a canvas / <see cref="CanavasManager"/>
	/// </summary>
	public interface ICanvasContainer
	{
		void CreateNewCanvas(double width, double height, bool addLayer = true);

		void Add(VectorImage image);

		void Add(DrawingCanvas canvas);

		void ResizeCanvas(double width, double height);

		void ZoomIn(int percent);

		void ZoomOut(int percent);

	}
}
