﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace WickedFlame.VecDraw.Dialog
{
    public enum DragDropDialogResult { 
		/// <summary>
		/// Open as a new image
		/// </summary>
		Open, 
		/// <summary>
		/// Add to the current image
		/// </summary>
		Add, 
		/// <summary>
		/// Do nothing
		/// </summary>
		None };

    /// <summary>
    /// Interaktionslogik für ImageDragDropDialog.xaml
    /// </summary>
    public partial class ImageDragDropDialog : WickedFlame.VecDraw.Base.Controls.VecDrawDialog
    {
        public ImageDragDropDialog()
        {
            InitializeComponent();
        }

        DragDropDialogResult _dlgResult = DragDropDialogResult.None;
        public DragDropDialogResult DragDropDialogResult
        {
            get
            {
                return _dlgResult;
            }
        }

        private void btnOpen_Click(object sender, RoutedEventArgs e)
        {
            _dlgResult = DragDropDialogResult.Open;
            this.DialogResult = true;
            this.Close();
        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            _dlgResult = DragDropDialogResult.Add;
            this.DialogResult = true;
            this.Close();
        }

        private void btnCancle_Click(object sender, RoutedEventArgs e)
        {
            _dlgResult = DragDropDialogResult.None;
            this.DialogResult = false;
            this.Close();
        }
    }
}
