﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WickedFlame.Util.Controls;
using System.Diagnostics;

namespace WickedFlame.VecDraw.Plugins
{
    /// <summary>
    /// Interaction logic for AboutDisplay.xaml
    /// </summary>
    public partial class AboutDisplay : HeaderedToolItem
    {
        public AboutDisplay()
        {
            InitializeComponent();
            this.AddHandler(Hyperlink.RequestNavigateEvent, new RoutedEventHandler(this.HandleRequestNavigate), false);
        }

        void HandleRequestNavigate(object sender, RoutedEventArgs e)
        {
            Hyperlink hl = (e.OriginalSource as Hyperlink);
            if (hl != null)
            {
                string navigateUri = hl.NavigateUri.ToString();
                Process.Start(new ProcessStartInfo(navigateUri));
                e.Handled = true;
            }
        }

    	public string Version
    	{
    		get
    		{
    			return "v" + System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.Major +
    			       "." +
    			       System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.Minor;
    			//    "." +
    			//    System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.Build;
    		}
    	}
    }
}
